/*
* E1.0.0 RAM Increment 1 Final Code
* December 2014
* Department of Veterans Affairs/Booz Allen Hamilton 
* 
*/


package gov.va.rams.business;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;

import org.apache.commons.collections.map.MultiValueMap;

public class RoleMapSingleton {

	// create an object of SingleObject
	private static RoleMapSingleton instance = new RoleMapSingleton();

	private static String filepath = "/usr/tomcat/cache/roles/";
	
	// make the constructor private so that this class cannot be
	// instantiated
	private RoleMapSingleton() {
	}

	// Get the only object available
	public static RoleMapSingleton getInstance() {
		return instance;
	}

	public String showMessage() {
		String mess = "It's alive.";
		return mess;
	}


	
	/**
	 * Reads data file of roles and places into HashMap
	 * @return HashMap
	 */
	public HashMap<String, Integer> getRoleMap() {

		HashMap<String, Integer> roleHashMap = new HashMap<String, Integer>();
		String filename = "roledata.txt";
		File file = new File(filepath + filename); // 
			
		FileReader fr;
		try {
			fr = new FileReader(file);

			BufferedReader br = new BufferedReader(new FileReader(file));
			//int roleIndex = 0;
			String line;
			String role = "";
			String roleid = "";
			

			while ((line = br.readLine()) != null) {
				
				System.out.println("position = " + line.indexOf(" : "));
				
				role = line.substring(0, line.indexOf(" : "));
				roleid = line.substring(line.indexOf(" : ")+3 , line.length());
				System.out.println("RoleId:[" + roleid + "] Role:[" + role +"]");
				System.out.println("RoleId:" + roleid.trim() + " Role:" + role.trim());
				
				roleHashMap.put(role.trim(), Integer.parseInt(roleid.trim()));
				
				
				//roleIndex++;
			}

			br.close();
			fr.close();
		} catch (FileNotFoundException e1) {
			e1.printStackTrace();
			System.out.println("Error1 " + e1.getMessage());
		} catch (IOException e2) {
			System.out.println("Error2 " + e2.getMessage());
			e2.printStackTrace();
		}

		return roleHashMap;

	}
	
	/**
	 * Updates role data file with role and role id
	 * @param id
	 * @param role
	 * @return boolean
	 */
	public boolean updateRole(String id, String role) {
		String filename = "roledata.txt";
		boolean success = false;
		try (
				FileWriter fw = new FileWriter(filepath + filename, true);
				BufferedWriter bw = new BufferedWriter(fw);
				PrintWriter pwout = new PrintWriter(bw)
			
			) 
		{
			//append file
			System.out.println("Updating roledata file, Role = " + role + " id = " + id);
			pwout.println(role + " : " + id);
			success = true;
		} catch (IOException e) {
			
		}
		
		return success;
		
	}
	
	/**
	 * Reads data file of roles and places into HashMap
	 * @return HashMap
	 */
	public MultiValueMap getUserRoleMap() {

		MultiValueMap userRroleHashMap = new MultiValueMap();
		String filename = "userroledata.txt";
		File file = new File(filepath + filename); // 
			
		FileReader fr;
		try {
			fr = new FileReader(file);

			BufferedReader br = new BufferedReader(new FileReader(file));
			//int roleIndex = 0;
			String line;
			String userid = "";
			String roleid = "";
			

			while ((line = br.readLine()) != null) {
				System.out.println("position = " + line.indexOf(" : "));
				
				//key - each role has multiple userid's
				roleid = line.substring(line.indexOf(" : ")+3, line.length());
				//value
				userid = line.substring(0, line.indexOf(" : "));
				
				System.out.println("userid:[" + userid + "] roleid:[" + roleid +"]");
				
				userRroleHashMap.put(Integer.parseInt(roleid.trim()), Integer.parseInt(userid.trim()));
			}

			br.close();
			fr.close();
		} catch (FileNotFoundException e1) {
			e1.printStackTrace();
			System.out.println("Error1 " + e1.getMessage());
		} catch (IOException e2) {
			System.out.println("Error2 " + e2.getMessage());
			e2.printStackTrace();
		}

		return userRroleHashMap;

	}
	
	/**
	 * Updates userrole data file with role and role id
	 * @param id
	 * @param role
	 * @return boolean
	 */
	public boolean updateUserRole(String userid, String roleid) {
		String filename = "userroledata.txt";
		boolean success = false;
		try (
				FileWriter fw = new FileWriter(filepath + filename, true);
				BufferedWriter bw = new BufferedWriter(fw);
				PrintWriter pwout = new PrintWriter(bw)
			
			) 
		{
			System.out.println("Updating userroledata file, User Id  = " + userid + " Role Id = " + roleid);
			//append file
			pwout.println(userid + " : " + roleid);
			success = true;
		} catch (IOException e) {
			
		}
		
		return success;
		
	}

}