/*
* E1.0.0 RAM Increment 1 Final Code
* December 2014
* Department of Veterans Affairs/Booz Allen Hamilton 
* 
*/

package gov.va.rams.entities;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author Brian
 */
@Entity
@Table(name = "Answers")
@XmlRootElement
public class Answer implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "AnswersID")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer answersID;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 1000)
    @Column(name = "Value")
    private String value;
    @Basic(optional = false)
    @NotNull
    @Column(name = "SequencePosition")
    private int sequencePosition;
    @JoinColumn(name = "QuestionsID", referencedColumnName = "QuestionsID")
    @ManyToOne(optional = false)
    private Question question;

    public Answer() {
    }

    public Integer getAnswersID() {
        return answersID;
    }

    public void setAnswersID(Integer answersID) {
        this.answersID = answersID;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    @XmlTransient
    public Question getQuestion() {
        return question;
    }

    public void setQuestion(Question question) {
        this.question = question;
    }
    
    public int getSequencePosition() {
        return sequencePosition;
    }

    public void setSequencePosition(int sequencePosition) {
        this.sequencePosition = sequencePosition;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (answersID != null ? answersID.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Answer)) {
            return false;
        }
        Answer other = (Answer) object;
        if ((this.answersID == null && other.answersID != null) || (this.answersID != null && !this.answersID.equals(other.answersID))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.va.rams.entities.Answer[ answersID=" + answersID + " ]";
    }
    
}
