/*
* E1.0.0 RAM Increment 1 Final Code
* December 2014
* Department of Veterans Affairs/Booz Allen Hamilton 
* 
*/

package gov.va.rams.entities;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author Brian
 */
@Entity
@Table(name = "Contained_Forms")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "ContainedForm.findAll", query = "SELECT c FROM ContainedForm c")})
public class ContainedForm implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "ContainedFormsID")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer containedFormsID;
    @Basic(optional = false)
    @NotNull
    @Column(name = "FormSequencePosition")
    private int formSequencePosition;
    private Integer requiredPredecessorAnswersID;
    @JoinColumn(name = "ContainerID", referencedColumnName = "FormsID", updatable = false)
    @ManyToOne(optional = false)
    private Form containerForm;
    @JoinColumn(name = "ContentID", referencedColumnName = "FormsID", updatable = false)
    @ManyToOne(optional = false, cascade = CascadeType.PERSIST)
    private Form containedForm;
    private Integer requiredPredecessorQuestionsID;

    public ContainedForm() {
    }

    public int getFormSequencePosition() {
        return formSequencePosition;
    }

    public void setFormSequencePosition(int formSequencePosition) {
        this.formSequencePosition = formSequencePosition;
    }

    public Integer getRequiredPredecessorAnswersID() {
        return requiredPredecessorAnswersID;
    }

    public void setRequiredPredecessorAnswersID(Integer requiredPredecessorAnswersID) {
        this.requiredPredecessorAnswersID = requiredPredecessorAnswersID;
    }

    @XmlTransient
    public Form getContainerForm() {
        return containerForm;
    }

    public void setContainerForm(Form containerForm) {
        this.containerForm = containerForm;
    }

    public Form getContainedForm() {
        return containedForm;
    }

    public void setContainedForm(Form containedForm) {
        this.containedForm = containedForm;
    }

    public Integer getRequiredPredecessorQuestionsID() {
        return requiredPredecessorQuestionsID;
    }

    public void setRequiredPredecessorQuestionsID(Integer requiredPredecessorQuestionsID) {
        this.requiredPredecessorQuestionsID = requiredPredecessorQuestionsID;
    }

    public Integer getContainedFormsID() {
        return containedFormsID;
    }

    public void setContainedFormsID(Integer containedFormsID) {
        this.containedFormsID = containedFormsID;
    }
    
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (containedFormsID != null ? containedFormsID.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof ContainedForm)) {
            return false;
        }
        ContainedForm other = (ContainedForm) object;
        if ((this.containedFormsID == null && other.containedFormsID != null) || (this.containedFormsID != null && !this.containedFormsID.equals(other.containedFormsID))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.va.rams.entities.ContainedForm[ containedFormsID=" + containedFormsID + " ]";
    }

}
