/*
* E1.0.0 RAM Increment 1 Final Code
* December 2014
* Department of Veterans Affairs/Booz Allen Hamilton 
* 
*/

package gov.va.rams.entities;

import java.io.Serializable;
import java.util.Collection;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author Brian
 */
@Entity
@Table(name = "Facilities")
@XmlRootElement
@NamedQuery(name = "Facility.findAll", query = "SELECT f FROM Facility f")
public class Facility implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @NotNull
    @Column(nullable = false)
    private Integer facilitiesID;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 50)
    @Column(nullable = false, length = 50)
    private String name;
    @Size(max = 200)
    @Column(length = 200)
    private String description;
    @Size(max = 200)
    @Column(length = 200)
    private String address;
    @Basic(optional = false)
    @NotNull
    @Column(nullable = false)
    @Temporal(TemporalType.TIMESTAMP)
    private Date synchronizedTimestamp;
    @Basic(optional = false)
    @NotNull
    @Column(nullable = false)
    private int administratorSPGroup;
    @Basic(optional = false)
    @NotNull
    @Column(nullable = false)
    private int reviewerSPGroup;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 36)
    @Column(nullable = false, length = 36)
    private String reviewerSPCalendar;
    @Basic(optional = false)
    @NotNull
    @Column(nullable = false)
    private int safetySPGroup;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "facility")
    private Collection<FacilityMembership> facilityMembershipCollection;

    public Facility() {
    }

    public Integer getFacilitiesID() {
        return facilitiesID;
    }

    public void setFacilitiesID(Integer facilitiesID) {
        this.facilitiesID = facilitiesID;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public Date getSynchronizedTimestamp() {
        return synchronizedTimestamp;
    }

    public void setSynchronizedTimestamp(Date synchronizedTimestamp) {
        this.synchronizedTimestamp = synchronizedTimestamp;
    }

    public int getAdministratorSPGroup() {
        return administratorSPGroup;
    }

    public void setAdministratorSPGroup(int administratorSPGroup) {
        this.administratorSPGroup = administratorSPGroup;
    }

    public int getReviewerSPGroup() {
        return reviewerSPGroup;
    }

    public void setReviewerSPGroup(int reviewerSPGroup) {
        this.reviewerSPGroup = reviewerSPGroup;
    }

    public String getReviewerSPCalendar() {
        return reviewerSPCalendar;
    }

    public void setReviewerSPCalendar(String reviewerSPCalendar) {
        this.reviewerSPCalendar = reviewerSPCalendar;
    }

    public int getSafetySPGroup() {
        return safetySPGroup;
    }

    public void setSafetySPGroup(int safetySPGroup) {
        this.safetySPGroup = safetySPGroup;
    }

    @XmlTransient
    public Collection<FacilityMembership> getFacilityMembershipCollection() {
        return facilityMembershipCollection;
    }

    public void setFacilityMembershipCollection(Collection<FacilityMembership> facilityMembershipCollection) {
        this.facilityMembershipCollection = facilityMembershipCollection;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (facilitiesID != null ? facilitiesID.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Facility)) {
            return false;
        }
        Facility other = (Facility) object;
        if ((this.facilitiesID == null && other.facilitiesID != null) || (this.facilitiesID != null && !this.facilitiesID.equals(other.facilitiesID))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.va.rams.Facility[ facilitiesID=" + facilitiesID + " ]";
    }
    
}
