/*
* E1.0.0 RAM Increment 1 Final Code
* December 2014
* Department of Veterans Affairs/Booz Allen Hamilton 
* 
*/

package gov.va.rams.entities;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author Brian
 */
@Entity
@Table(name = "Facility_Membership", uniqueConstraints = {
    @UniqueConstraint(columnNames = {"FacilitiesID", "UsersID"})})
@XmlRootElement
@NamedQuery(name = "FacilityMembership.findByFacilityAndUser", query = "SELECT f FROM FacilityMembership f WHERE f.facility = :facility AND f.user = :user")
public class FacilityMembership implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(nullable = false)
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer facilityMembershipID;
    @Basic(optional = false)
    @NotNull
    @Column(nullable = false)
    private int SPGroup;
    @JoinColumn(name = "FacilitiesID", referencedColumnName = "FacilitiesID", nullable = false)
    @ManyToOne(optional = false)
    private Facility facility;
    @JoinColumn(name = "UsersID", referencedColumnName = "UsersID", nullable = false)
    @ManyToOne(optional = false)
    private User user;

    public FacilityMembership() {
    }

    public Integer getFacilityMembershipID() {
        return facilityMembershipID;
    }

    public void setFacilityMembershipID(Integer facilityMembershipID) {
        this.facilityMembershipID = facilityMembershipID;
    }

    public int getSPGroup() {
        return SPGroup;
    }

    public void setSPGroup(int SPGroup) {
        this.SPGroup = SPGroup;
    }

    @XmlTransient
    public Facility getFacility() {
        return facility;
    }

    public void setFacility(Facility facility) {
        this.facility = facility;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (facilityMembershipID != null ? facilityMembershipID.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof FacilityMembership)) {
            return false;
        }
        FacilityMembership other = (FacilityMembership) object;
        if ((this.facilityMembershipID == null && other.facilityMembershipID != null) || (this.facilityMembershipID != null && !this.facilityMembershipID.equals(other.facilityMembershipID))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.va.rams.FacilityMembership[ facilityMembershipID=" + facilityMembershipID + " ]";
    }
    
}
