/*
* E1.0.0 RAM Increment 1 Final Code
* December 2014
* Department of Veterans Affairs/Booz Allen Hamilton 
* 
*/

package gov.va.rams.entities;

import java.io.Serializable;
import java.util.Collection;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.OrderBy;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author Brian
 */
@Entity
@Table(name = "Forms")
@XmlRootElement
public class Form implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "FormsID")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer formsID;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 50)
    @Column(name = "Title")
    private String title;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 1073741823)
    @Column(name = "Narrative")
    private String narrative;
    @Basic(optional = false)
    @NotNull
    @Column(name = "IsPage")
    private boolean isPage;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "containerForm", fetch = FetchType.EAGER)
    @OrderBy("formSequencePosition")
    private Collection<ContainedForm> containedFormCollection;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "form", fetch = FetchType.EAGER)
    @OrderBy("formSequencePosition")
    private Collection<FormQuestion> formQuestionCollection;

    public Form() {
    }

    public Integer getFormsID() {
        return formsID;
    }

    public void setFormsID(Integer formsID) {
        this.formsID = formsID;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getNarrative() {
        return narrative;
    }

    public void setNarrative(String narrative) {
        this.narrative = narrative;
    }

    public boolean getIsPage() {
        return isPage;
    }

    public void setIsPage(boolean isPage) {
        this.isPage = isPage;
    }

    public Collection<ContainedForm> getContainedFormCollection() {
        return containedFormCollection;
    }

    public void setContainedFormCollection(Collection<ContainedForm> containedFormCollection) {
        this.containedFormCollection = containedFormCollection;
    }

    public Collection<FormQuestion> getFormQuestionCollection() {
        return formQuestionCollection;
    }

    public void setFormQuestionCollection(Collection<FormQuestion> formQuestionCollection) {
        this.formQuestionCollection = formQuestionCollection;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (formsID != null ? formsID.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Form)) {
            return false;
        }
        Form other = (Form) object;
        if ((this.formsID == null && other.formsID != null) || (this.formsID != null && !this.formsID.equals(other.formsID))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.va.rams.entities.Form[ formsID=" + formsID + " ]";
    }
    
}
