/*
* E1.0.0 RAM Increment 1 Final Code
* December 2014
* Department of Veterans Affairs/Booz Allen Hamilton 
* 
*/

package gov.va.rams.entities;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author Brian
 */
@Entity
@Table(name = "Forms_Questions")
@XmlRootElement
public class FormQuestion implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "FormsQuestionsID")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer formsQuestionsID;
    @Basic(optional = false)
    @NotNull
    @Column(name = "FormSequencePosition")
    private int formSequencePosition;
    private Integer requiredPredecessorAnswersID;
    @JoinColumn(name = "FormsID", referencedColumnName = "FormsID")
    @ManyToOne(optional = false)
    private Form form;
    @JoinColumn(name = "QuestionsID", referencedColumnName = "QuestionsID")
    @ManyToOne(optional = false, cascade = CascadeType.PERSIST)
    private Question question;
    private Integer requiredPredecessorQuestionsID;

    public FormQuestion() {
    }

    public Integer getFormsQuestionsID() {
        return formsQuestionsID;
    }

    public void setFormsQuestionsID(Integer formsQuestionsID) {
        this.formsQuestionsID = formsQuestionsID;
    }

    public int getFormSequencePosition() {
        return formSequencePosition;
    }

    public void setFormSequencePosition(int formSequencePosition) {
        this.formSequencePosition = formSequencePosition;
    }

    public Integer getRequiredPredecessorAnswersID() {
        return requiredPredecessorAnswersID;
    }

    public void setRequiredPredecessorAnswersID(Integer requiredPredecessorAnswersID) {
        this.requiredPredecessorAnswersID = requiredPredecessorAnswersID;
    }

    @XmlTransient
    public Form getForm() {
        return form;
    }

    public void setForm(Form form) {
        this.form = form;
    }

    public Question getQuestion() {
        return question;
    }

    public void setQuestion(Question question) {
        this.question = question;
    }

    public Integer getRequiredPredecessorQuestionsID() {
        return requiredPredecessorQuestionsID;
    }

    public void setRequiredPredecessorQuestionsID(Integer requiredPredecessorQuestionsID) {
        this.requiredPredecessorQuestionsID = requiredPredecessorQuestionsID;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (formsQuestionsID != null ? formsQuestionsID.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof FormQuestion)) {
            return false;
        }
        FormQuestion other = (FormQuestion) object;
        if ((this.formsQuestionsID == null && other.formsQuestionsID != null) || (this.formsQuestionsID != null && !this.formsQuestionsID.equals(other.formsQuestionsID))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.va.rams.entities.FormQuestion[ formsQuestionsID=" + formsQuestionsID + " ]";
    }
    
}
