/*
* E1.0.0 RAM Increment 1 Final Code
* December 2014
* Department of Veterans Affairs/Booz Allen Hamilton 
* 
*/

package gov.va.rams.entities;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author Brian
 */
@Entity
@Table(name = "Form_Versions")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "FormVersion.findAll", query = "SELECT f FROM FormVersion f"),
    @NamedQuery(name = "FormVersion.findNewest", query = "SELECT f from FormVersion f ORDER BY f.startedUsingAt DESC")})
public class FormVersion implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "FormVersionsID")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer formVersionsID;
    @Basic(optional = false)
    @NotNull
    @Column(name = "StartedUsingAt")
    @Temporal(TemporalType.TIMESTAMP)
    private Date startedUsingAt;
    @JoinColumn(name = "RootFormsID", referencedColumnName = "FormsID")
    @ManyToOne(optional = false, cascade = CascadeType.PERSIST, fetch = FetchType.LAZY)
    private Form rootForm;

    public FormVersion() {
    }

    public Integer getFormVersionsID() {
        return formVersionsID;
    }

    public void setFormVersionsID(Integer formVersionsID) {
        this.formVersionsID = formVersionsID;
    }

    public Date getStartedUsingAt() {
        return startedUsingAt;
    }

    public void setStartedUsingAt(Date startedUsingAt) {
        this.startedUsingAt = startedUsingAt;
    }

    @XmlTransient
    public Form getRootForm() {
        return rootForm;
    }

    public void setRootForm(Form rootForm) {
        this.rootForm = rootForm;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (formVersionsID != null ? formVersionsID.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof FormVersion)) {
            return false;
        }
        FormVersion other = (FormVersion) object;
        if ((this.formVersionsID == null && other.formVersionsID != null) || (this.formVersionsID != null && !this.formVersionsID.equals(other.formVersionsID))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.va.rams.entities.FormVersion[ formVersionsID=" + formVersionsID + " ]";
    }
    
}
