/*
* E1.0.0 RAM Increment 1 Final Code
* December 2014
* Department of Veterans Affairs/Booz Allen Hamilton 
* 
*/

package gov.va.rams.entities;

import java.io.Serializable;
import java.util.Collection;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.Lob;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OrderBy;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author Brian
 */
@Entity
@Table(name = "Questions")
@XmlRootElement
public class Question implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "QuestionsID")
    private Integer questionsID;
    @Basic(optional = false)
    @NotNull
    @Lob
    @Size(min = 1, max = 2147483647)
    @Column(name = "QuestionHyperText")
    private String questionHyperText;
    @Lob
    @Size(max = 2147483647)
    @Column(name = "OtherOptionHyperText")
    private String otherOptionHyperText;
    @Lob
    @Size(max = 2147483647)
    @Column(name = "HelpHyperText")
    private String helpHyperText;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "question", fetch = FetchType.EAGER)
    @OrderBy("sequencePosition")
    private Collection<Answer> answerCollection;
    @JoinColumn(name = "ResponseFormatsID", referencedColumnName = "ResponseFormatsID")
    @ManyToOne(optional = false)
    private ResponseFormat responseFormat;

    public Question() {
    }

    public Integer getQuestionsID() {
        return questionsID;
    }

    public void setQuestionsID(Integer questionsID) {
        this.questionsID = questionsID;
    }

    public String getQuestionHyperText() {
        return questionHyperText;
    }

    public void setQuestionHyperText(String questionHyperText) {
        this.questionHyperText = questionHyperText;
    }
    
    
    public String getOtherOptionHyperText() {
        return otherOptionHyperText;
    }

    public void setOtherOptionHyperText(String otherOptionHyperText) {
        this.otherOptionHyperText = otherOptionHyperText;
    }

    public String getHelpHyperText() {
        return helpHyperText;
    }

    public void setHelpHyperText(String helpHyperText) {
        this.helpHyperText = helpHyperText;
    }

    public Collection<Answer> getAnswerCollection() {
        return answerCollection;
    }

    public void setAnswerCollection(Collection<Answer> answerCollection) {
        this.answerCollection = answerCollection;
    }

    public ResponseFormat getResponseFormat() {
        return responseFormat;
    }

    public void setResponseFormat(ResponseFormat responseFormat) {
        this.responseFormat = responseFormat;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (questionsID != null ? questionsID.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Question)) {
            return false;
        }
        Question other = (Question) object;
        if ((this.questionsID == null && other.questionsID != null) || (this.questionsID != null && !this.questionsID.equals(other.questionsID))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.va.rams.entities.Question[ questionsID=" + questionsID + " ]";
    }
    
}
