/*
* E1.0.0 RAM Increment 1 Final Code
* December 2014
* Department of Veterans Affairs/Booz Allen Hamilton 
* 
*/

package gov.va.rams.entities;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Lob;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author Brian
 */
@Entity
@Table(name = "Response_Formats")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "ResponseFormat.findAll", query = "SELECT r FROM ResponseFormat r")})
public class ResponseFormat implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(name = "ResponseFormatsID")
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer responseFormatsID;
    @Basic(optional = false)
    @NotNull
    @Lob
    @Size(min = 1, max = 2147483647)
    @Column(name = "Name")
    private String name;
    @Lob
    @Size(max = 2147483647)
    @Column(name = "Description")
    private String description;
    @Lob
    @Size(max = 2147483647)
    @Column(name = "ErrorMessage")
    private String errorMessage;
    @Lob
    @Size(max = 2147483647)
    @Column(name = "ValidationLogic")
    private String validationLogic;
    @Lob
    @Size(max = 2147483647)
    @Column(name = "Layout")
    private String layout;

    public ResponseFormat() {
    }

    public Integer getResponseFormatsID() {
        return responseFormatsID;
    }

    public void setResponseFormatsID(Integer responseFormatsID) {
        this.responseFormatsID = responseFormatsID;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getErrorMessage() {
        return errorMessage;
    }

    public void setErrorMessage(String errorMessage) {
        this.errorMessage = errorMessage;
    }

    public String getValidationLogic() {
        return validationLogic;
    }

    public void setValidationLogic(String validationLogic) {
        this.validationLogic = validationLogic;
    }

    public String getLayout() {
        return layout;
    }

    public void setLayout(String layout) {
        this.layout = layout;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (responseFormatsID != null ? responseFormatsID.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof ResponseFormat)) {
            return false;
        }
        ResponseFormat other = (ResponseFormat) object;
        if ((this.responseFormatsID == null && other.responseFormatsID != null) || (this.responseFormatsID != null && !this.responseFormatsID.equals(other.responseFormatsID))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.va.rams.entities.ResponseFormat[ responseFormatsID=" + responseFormatsID + " ]";
    }
    
}
