/*
* E1.0.0 RAM Increment 1 Final Code
* December 2014
* Department of Veterans Affairs/Booz Allen Hamilton 
* 
*/

package gov.va.rams.entities;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author Brian
 */
@Entity
@Table(name = "Study_States")
@NamedQuery(name = "StudyState.findByName", query = "SELECT s FROM StudyState s WHERE s.name = :name")
@XmlRootElement
public class StudyState implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @Column(nullable = false)
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer studyStatesID;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 10)
    @Column(nullable = false, length = 10)
    private String name;

    public StudyState() {
    }

    public Integer getStudyStatesID() {
        return studyStatesID;
    }

    public void setStudyStatesID(Integer studyStatesID) {
        this.studyStatesID = studyStatesID;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (studyStatesID != null ? studyStatesID.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof StudyState)) {
            return false;
        }
        StudyState other = (StudyState) object;
        if ((this.studyStatesID == null && other.studyStatesID != null) || (this.studyStatesID != null && !this.studyStatesID.equals(other.studyStatesID))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.va.rams.StudyState[ studyStatesID=" + studyStatesID + " ]";
    }
    
}
