/*
* E1.0.0 RAM Increment 1 Final Code
* December 2014
* Department of Veterans Affairs/Booz Allen Hamilton 
* 
*/

package gov.va.rams.entities;

import java.io.Serializable;
import java.util.Collection;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.UniqueConstraint;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author Brian
 */
@Entity
@Table(name = "Study_Status", uniqueConstraints = {
    @UniqueConstraint(columnNames = {"StudyStatusID", "StageCounter"})})
@XmlRootElement
public class StudyStatus implements Serializable {
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "StudyStatusID")
    private Integer studyStatusID;
    @Basic(optional = false)
    @NotNull
    @Column(name = "StageCounter")
    private int stageCounter;
    @Basic(optional = false)
    @NotNull
    @Column(name = "CreatedAt")
    @Temporal(TemporalType.TIMESTAMP)
    private Date createdAt;
    @Basic(optional = false)
    @NotNull
    @Column(name = "UpdatedAt")
    @Temporal(TemporalType.TIMESTAMP)
    private Date updatedAt;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "studyStatus")
    private Collection<QuestionResponse> questionResponseCollection;
    private static final long serialVersionUID = 1L;
    @JoinTable(name = "Study_Status_Reviewers", joinColumns = {
        @JoinColumn(name = "StudyStatusID", referencedColumnName = "StudyStatusID", nullable = false)}, inverseJoinColumns = {
        @JoinColumn(name = "UsersID", referencedColumnName = "UsersID", nullable = false)})
    @ManyToMany
    private Collection<User> reviewerCollection;
    @JoinColumn(name = "StudiesID", referencedColumnName = "StudiesID", nullable = false)
    @ManyToOne(optional = false)
    private Study study;
    @JoinColumn(name = "StudyStatesID", referencedColumnName = "StudyStatesID", nullable = false)
    @ManyToOne(optional = false)
    private StudyState studyState;
    @JoinColumn(name = "CreatedBy", referencedColumnName = "UsersID", nullable = false)
    @ManyToOne(optional = false)
    private User createdBy;
    @JoinColumn(name = "UpdatedBy", referencedColumnName = "UsersID", nullable = false)
    @ManyToOne(optional = false)
    private User updatedBy;

    public StudyStatus() {
    }

    public Integer getStudyStatusID() {
        return studyStatusID;
    }

    public void setStudyStatusID(Integer studyStatusID) {
        this.studyStatusID = studyStatusID;
    }

    public int getStageCounter() {
        return stageCounter;
    }

    public void setStageCounter(int stageCounter) {
        this.stageCounter = stageCounter;
    }

    public Date getCreatedAt() {
        return createdAt;
    }

    public void setCreatedAt(Date createdAt) {
        this.createdAt = createdAt;
    }

    public Date getUpdatedAt() {
        return updatedAt;
    }

    public void setUpdatedAt(Date updatedAt) {
        this.updatedAt = updatedAt;
    }

    public Collection<User> getReviewerCollection() {
        return reviewerCollection;
    }

    public void setReviewerCollection(Collection<User> reviewerCollection) {
        this.reviewerCollection = reviewerCollection;
    }

    @XmlTransient
    public Study getStudy() {
        return study;
    }

    public void setStudy(Study study) {
        this.study = study;
    }

    public StudyState getStudyState() {
        return studyState;
    }

    public void setStudyState(StudyState studyState) {
        this.studyState = studyState;
    }

    public User getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(User createdBy) {
        this.createdBy = createdBy;
    }

    public User getUpdatedBy() {
        return updatedBy;
    }

    public void setUpdatedBy(User updatedBy) {
        this.updatedBy = updatedBy;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (studyStatusID != null ? studyStatusID.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof StudyStatus)) {
            return false;
        }
        StudyStatus other = (StudyStatus) object;
        if ((this.studyStatusID == null && other.studyStatusID != null) || (this.studyStatusID != null && !this.studyStatusID.equals(other.studyStatusID))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "gov.va.rams.StudyStatus[ studyStatusID=" + studyStatusID + " ]";
    }

    @XmlTransient
    public Collection<QuestionResponse> getQuestionResponseCollection() {
        return questionResponseCollection;
    }

    public void setQuestionResponseCollection(Collection<QuestionResponse> questionResponseCollection) {
        this.questionResponseCollection = questionResponseCollection;
    }

}
