/*
* E1.0.0 RAM Increment 1 Final Code
* December 2014
* Department of Veterans Affairs/Booz Allen Hamilton 
* 
*/

package gov.va.rams.service;

import java.util.HashMap;
import java.util.Map;
import java.util.Calendar;
import java.util.Random;
import java.util.Iterator;

import java.nio.file.*; 

import java.io.File;
import java.io.FileOutputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.ObjectOutputStream;
import java.io.ObjectInputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;

import gov.va.rams.business.RoleMapSingleton;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import javax.ejb.Stateless;
import javax.servlet.ServletContext;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.DELETE;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.HttpHeaders;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.HeaderParam;

import org.apache.commons.collections.map.MultiValueMap;
import org.codehaus.jettison.json.JSONException;
import org.codehaus.jettison.json.JSONObject;
import org.codehaus.jettison.json.JSONArray;

import javax.ejb.EJB;

import org.apache.cxf.jaxrs.ext.multipart.*; 

import gov.va.rams.entities.Study;

/**
 *
 * @author Alan
 */
@Stateless

@Path("fascade")
public class MockServiceREST {
    
    @javax.ws.rs.core.Context HttpHeaders requestHeaders;
    @javax.ws.rs.core.Context ServletContext context;

   
    @GET
    @Path("test")
    @Consumes(MediaType.APPLICATION_JSON)
    @Produces(MediaType.APPLICATION_JSON)
    public Response getMessage() {
        System.out.println("Alan found");
         RoleMapSingleton object = RoleMapSingleton.getInstance();

         //show the message
         String temp = object.showMessage();
         return Response.status(200).entity(temp).build();
    }
   
    @GET
    @Path("roles")
    @Consumes(MediaType.APPLICATION_JSON)
    @Produces(MediaType.APPLICATION_JSON)
    public String getRoles() {
         RoleMapSingleton rms = RoleMapSingleton.getInstance();

         //show the message
         HashMap<?, ?> map = rms.getRoleMap();
         
         JSONObject json = new JSONObject();
         try {
            json.put("roles", map);
        } catch (JSONException e) {
            e.printStackTrace();
            System.out.println(e.getMessage());
        }
         return json.toString();
    }
    
    @POST
    @Path("setrole/{id}/role/{rolename}")
    @Consumes(MediaType.TEXT_PLAIN)
    @Produces(MediaType.TEXT_PLAIN)
    public boolean setRole( @PathParam ("id") String id, @PathParam ("rolename") String rolename){
        boolean success = false;
        
        RoleMapSingleton rms = RoleMapSingleton.getInstance();
        
        success = rms.updateRole(id, rolename);
        
        return success;
    }
    
    @GET
    @Path("userroles")
    @Consumes(MediaType.APPLICATION_JSON)
    @Produces(MediaType.APPLICATION_JSON)
    public String getUserRoles() {
         RoleMapSingleton rms = RoleMapSingleton.getInstance();

         //show the message
         MultiValueMap map = rms.getUserRoleMap();
         
         JSONObject json = new JSONObject();
         try {
            json.put("userroles", map);
        } catch (JSONException e) {
            e.printStackTrace();
            System.out.println(e.getMessage());
        }
         return json.toString();
    }
    
    @POST
    @Path("setuserrole/{userid}/roleid/{roleid}")
    @Consumes(MediaType.TEXT_PLAIN)
    @Produces(MediaType.TEXT_PLAIN)
    public boolean setUserRole( @PathParam ("userid") String userid, @PathParam ("roleid") String roleid){
        boolean success = false;
        
        RoleMapSingleton rms = RoleMapSingleton.getInstance();
        
        success = rms.updateUserRole(userid, roleid);
        
        return success;
    }

    String static_file_location = "/usr/tomcat/uploads/";
    
    /* public class FileOnlyFileName {
        public String filename;
        public String login_name;
        public String study_id;
        public String tags;

    }    */

    @POST
    @Path("file/upload/onlyfilename")
    public boolean upload_filename_only(@HeaderParam("filename") String filename,@HeaderParam("login_name") String login_name,@HeaderParam("study_id") String study_id,@HeaderParam("tags") String tags) throws IOException {
        
        
        //handle files
        
        java.nio.file.Path path = Paths.get(static_file_location + "/" + study_id + "/" + filename);
        
        File rootDir = new File(static_file_location);
        File studyDir = new File(static_file_location + "/" + study_id );    
        
        if(!rootDir.exists()) {
            try{
                rootDir.mkdir();
                studyDir.mkdir();
                
            } catch (SecurityException se){
                System.out.println(se.getMessage());
            }
        }
        
        else if(!studyDir.exists()) {
            try{
                studyDir.mkdir();
                
            } catch (SecurityException se){
                System.out.println(se.getMessage());
            }
        }
        
        //InputStream in = attachment.getObject(InputStream.class);
        //Files.copy(in, path,StandardCopyOption.REPLACE_EXISTING);
        
        File fileName_mock = new File(static_file_location + "/" + study_id + "/" + filename);

        if(fileName_mock.exists()){
            fileName_mock.delete();
            fileName_mock.createNewFile();
        }
        else
            fileName_mock.createNewFile();

        //handle tags
        if (tags==null)
                tags="";
        
        Map<String, List<String>> tagsMap = new HashMap<>();

        File tagsDir = new File(static_file_location + "/" + study_id + "/" + "filesuserstags.dat");

        if(!tagsDir.exists()){
            List<String> UserTags = new ArrayList<String>();
            UserTags.add(login_name);
            UserTags.add(tags);
            tagsMap.put(filename,UserTags);
            try{

                FileOutputStream fos = new FileOutputStream(tagsDir);
                ObjectOutputStream oos = new ObjectOutputStream(fos);
                oos.writeObject(tagsMap);
                oos.close();

            } catch(Exception e){
                e.printStackTrace();
                return false;
            }
            return true;
        }

        else{
            try{
                FileInputStream fis = new FileInputStream(tagsDir);
                ObjectInputStream ois = new ObjectInputStream(fis);
                tagsMap = (Map<String,List<String>>)ois.readObject();
                ois.close();

                List<String> UserTags = new ArrayList<String>();
                UserTags.add(login_name);
                UserTags.add(tags);
                tagsMap.put(filename,UserTags);

                FileOutputStream fos = new FileOutputStream(tagsDir);
                ObjectOutputStream oos = new ObjectOutputStream(fos);
                oos.writeObject(tagsMap);
                oos.close();
                

            } catch(Exception e){
                e.printStackTrace();
                return false;
            }
            return true;
        }

    }


    @POST
    @Path("file/upload")
    @Consumes(MediaType.MULTIPART_FORM_DATA)
    public boolean upload(@Multipart("file") Attachment attachment, 
            @Multipart("login_name") String login_name,
            @Multipart("study_id") String study_id,
            @Multipart("tags") String tags) throws IOException {
        
        //handle files

        String filename = attachment.getContentDisposition().getParameter("filename");
        
        java.nio.file.Path path = Paths.get(static_file_location + "/" + study_id + "/" + filename);
        
        File rootDir = new File(static_file_location);
        File studyDir = new File(static_file_location + "/" + study_id );    
        
        if(!rootDir.exists()) {
            try{
                rootDir.mkdir();
                studyDir.mkdir();
                
            } catch (SecurityException se){
                System.out.println(se.getMessage());
            }
        }
        
        else if(!studyDir.exists()) {
            try{
                studyDir.mkdir();
                
            } catch (SecurityException se){
                System.out.println(se.getMessage());
            }
        }
        
        InputStream in = attachment.getObject(InputStream.class);
        Files.copy(in, path,StandardCopyOption.REPLACE_EXISTING);
        
        //handle tags
        if (tags==null)
                tags="";
        
        Map<String, List<String>> tagsMap = new HashMap<>();

        File tagsDir = new File(static_file_location + "/" + study_id + "/" + "filesuserstags.dat");

        if(!tagsDir.exists()){
            List<String> UserTags = new ArrayList<String>();
            UserTags.add(login_name);
            UserTags.add(tags);
            tagsMap.put(filename,UserTags);
            try{

                FileOutputStream fos = new FileOutputStream(tagsDir);
                ObjectOutputStream oos = new ObjectOutputStream(fos);
                oos.writeObject(tagsMap);
                oos.close();

            } catch(Exception e){
                e.printStackTrace();
                return false;
            }
            return true;
        }

        else{
            try{
                FileInputStream fis = new FileInputStream(tagsDir);
                ObjectInputStream ois = new ObjectInputStream(fis);
                tagsMap = (Map<String,List<String>>)ois.readObject();
                ois.close();

                List<String> UserTags = new ArrayList<String>();
                UserTags.add(login_name);
                UserTags.add(tags);
                tagsMap.put(filename,UserTags);

                FileOutputStream fos = new FileOutputStream(tagsDir);
                ObjectOutputStream oos = new ObjectOutputStream(fos);
                oos.writeObject(tagsMap);
                oos.close();
                

            } catch(Exception e){
                e.printStackTrace();
                return false;
            }
            return true;
        }

    }
    

    @DELETE
    @Path("file/delete/study/{id}/filename/{filename}")
    public boolean deleteStudyFile(@PathParam("id") String study_id, @PathParam("filename") String filename){
        java.nio.file.Path path = Paths.get(static_file_location + "/" + study_id + "/" + filename);
 
        try{
            Files.delete(path);
            File tagsDir = new File(static_file_location + "/" + study_id + "/" + "filesuserstags.dat");
            Map<String, List<String>> tagsMap = new HashMap<>();

            FileInputStream fis = new FileInputStream(tagsDir);
            ObjectInputStream ois = new ObjectInputStream(fis);
            tagsMap = (Map<String,List<String>>)ois.readObject();
            ois.close();            

            tagsMap.remove(filename);

            FileOutputStream fos = new FileOutputStream(tagsDir);
            ObjectOutputStream oos = new ObjectOutputStream(fos);
            oos.writeObject(tagsMap);
            oos.close();

            return true;
        }catch (NoSuchFileException e){
            e.printStackTrace();
            return false;
        }catch (IOException e){
            e.printStackTrace();
            return false;
        }catch (Exception e){
            e.printStackTrace();
            return false;
        }
    }

    @GET
    @Path("file/querystudy/{id}")
    public Response queryStudy(@PathParam ("id") String study_id){
                
        File studyDir = new File(static_file_location + "/" + study_id );
        
        if(!studyDir.exists()){
            return Response.noContent().build();
        }

        Map<String, List<String>> tagsMap = new HashMap<>();

        File tagsDir = new File(static_file_location + "/" + study_id + "/" + "filesuserstags.dat");

        try{
                FileInputStream fis = new FileInputStream(tagsDir);
                ObjectInputStream ois = new ObjectInputStream(fis);
                tagsMap = (Map<String,List<String>>)ois.readObject();
                ois.close();

            } catch(Exception e){
                e.printStackTrace();
                return Response.noContent().build();
            }

        JSONObject outerjson = new JSONObject();
        try{
            Iterator it = tagsMap.entrySet().iterator();
            List<JSONObject> files = new ArrayList<JSONObject>();
            
            while(it.hasNext()){
                Map.Entry pairs = (Map.Entry)it.next();
                    JSONObject json = new JSONObject();
                    json.put("file",pairs.getKey());
                    JSONArray details = new JSONArray();
                        JSONObject detailsData = new JSONObject();
                        List<String> temp = new ArrayList();
                        temp = (List)pairs.getValue();
                        detailsData.put("user",temp.get(0));
                        detailsData.put("tags",temp.get(1));
                    details.put(detailsData);
                    json.put("details",details);
                files.add(json);
            }
            outerjson.put("files",files);
            return Response.ok(outerjson.toString(4),MediaType.APPLICATION_JSON).build();
        }catch(Exception e){
            e.printStackTrace();
        } 

        return Response.noContent().build();

    }

    @PersistenceContext(unitName = "RAMSPU")
    private EntityManager em;

    @GET
    @Path("studyidgenerator/sitecode/{siteCode}/humorani/{HumOrAni}")
    @Produces(MediaType.APPLICATION_JSON)
    public String studyIDGen(@PathParam ("siteCode") String siteCode, 
        @PathParam ("HumOrAni") String HumOrAni) {
         
            int max = 9;
            int min = 0;
             
            int digits = 6;
             
            int i=0;
             
            String id = new String();
            do{
            id = "";

            id += siteCode;
             
            while(i++<digits)
            id += String.valueOf(new Random().nextInt((max - min) + 1) + min);
             
            //id += Year;
            id += String.valueOf(Calendar.getInstance().get(Calendar.YEAR));
             
            id += HumOrAni;
            
            System.out.println(id);

            } while(em.createNamedQuery("Study.findByAssignedID", Study.class).setParameter("assignedID", id).getResultList().size()!=0);

        System.out.println(em.createNamedQuery("Study.findByAssignedID", Study.class).setParameter("assignedID", id).getResultList().size());

         JSONObject json = new JSONObject();
         try {
            json.put("studyAssignedID", id);
        } catch (JSONException e) {
            e.printStackTrace();
            System.out.println(e.getMessage());
        }
         return json.toString();
    }

}