var study, rollup, recentStage, feedResponse, changedQuestions;

var dependency = new Hashtable();

//window.onbeforeunload = releaseAllLocks;

//Setting rest endpoints for VA and local machines
//local
var restPath = "../../RAMS-0.0.1/";
//VA
//var restPath = "../../../RAMS-0.0.1/";

//*********
//TEST CODE
//*********
var currentUser={
    "displayName": null,
    "loginName": null,
    "permanentLoginIdentifier": null,
    "usersID": null
};

//*********
//TEST CODE
//*********
var currentFacility={
    "administratorSPGroup": null,
    "description": null,
    "facilitiesID": null,
    "name": null,
    "reviewerSPCalendar": null,
    "reviewerSPGroup": null,
    "safetySPGroup": null
};


function releaseAllLocks(){
    var allUsers, allForms, status;
    console.log("RELEASING LOCKS");
    
    //getting all users in the database
    allUsers = sendREST("GET", "user", null, false);
    
    for(var i=0; i<1; i++){
	for(var j=0; j<study.form.containedFormCollection.length; j++){
	    status = sendREST("DELETE", "study/1/lock_a/"+study.form.containedFormCollection[j].containedForm.formsID, allUsers.user[i].loginName, false);
	    if(status == true){
		console.log("SUCCESS: " +allUsers.user[i].loginName+ " from: " +study.form.containedFormCollection[j].containedForm.formsID);
	    }else{
		console.log("FAILED: " +allUsers.user[i].loginName+ " from: " +study.form.containedFormCollection[j].containedForm.formsID);
	    }
	}
    }
};

function process(){
    //getting the most recent stage
    studyResponse = sendREST("GET", "study/1", null, false);
    if(studyResponse.study.studyStatusCollection.length === undefined){
	recentStage = 1;
    }else{
	recentStage = studyResponse.study.studyStatusCollection.length;
    }
    
    //most recent forms
    recentForms = studyResponse.study.formVersionsID;

    //getting all initial questions
    study = sendREST("GET", "forms/"+recentForms, null, false);

    //getting the rollup
    rollup = sendREST("GET", "study/1/responses/"+recentStage+"/rollup", null, false);
    
    
    sectionBuilder(0);
    subscriptionFeed();
};

//sets up the structure of the question/sidebar section and 
//attaches to the proper area in webpage.
function sectionBuilder(targetSection){
    $('div.row').remove();
    var section, row, column, sideColumn;
    
    //setting up the initial structure
    row = document.createElement("div");
    row.setAttribute("class", "row");
    $('div#insert').append(row);

    column = document.createElement("div");
    column.setAttribute("class", "col-xs-9");
    $('div.row').append(column);

    columnBuilder(targetSection);

    sideColumn = document.createElement("div");
    sideColumn.setAttribute("class", "col-xs-3 toolbar");
    $('div.row').append(sideColumn);

    sideColumnBuilder(targetSection);
};

//sets up the structure of the question area; includes header,
//questions, and button dock (progress buttons)
function columnBuilder(targetSection){
    var pageHeader, formContent, progressContainer;

    section = study.form.containedFormCollection[targetSection];

    //page header
    pageHeader = document.createElement("div");
    pageHeader.setAttribute("class", "page-header");
    $('div.col-xs-9').append(pageHeader);

    headerBuilder(targetSection);

    //questions
    formContent = document.createElement("div");
    formContent.setAttribute("class", "formContent");
    $('div.col-xs-9').append(formContent);

    questionBuilder(section);
    
    //progress buttons
    progressContainer = document.createElement("div");
    progressContainer.setAttribute("class", "progress-container");
    $('div.col-xs-9').append(progressContainer);

    progressBuilder(targetSection);

};

//Sets up the structure of the sidebar; includes section buttons, print and upload buttons,
//and review and submit buttons.
function sideColumnBuilder(targetSection){
    var actionBar, wsBar;

    //action bar
    actionBar = document.createElement("div");
    actionBar.setAttribute("class", "actionbar");
    $('div.col-xs-3').append(actionBar);

    actionBarBuilder(targetSection);

    //well sidebar
    wsBar = document.createElement("div");
    wsBar.setAttribute("class", "well sidebar");
    $('div.col-xs-3').append(wsBar);

    wellSidebarBuilder(targetSection);

};

//builds the header that displays information about a study and section.
function headerBuilder(targetSection){
    var appTitle, id, section, sectionContainer, genInfo, comp;

    //*********
    //TEST CODE
    //*********
    $('div.page-header').append(selectTest());

    //TITLE OF STUDY
    appTitle = document.createElement("h2");
    appTitle.setAttribute("class", "applicationTitle");
    
    //should contain title of IRB study
    var text = document.createTextNode("New IRB Application");
    appTitle.appendChild(text);

    //id of study
    id = document.createElement("small");
    
    //should contain id of IRB study
    var text = document.createTextNode(" ID: TBD");
    id.appendChild(text);
    appTitle.appendChild(id);

    $('div.page-header').append(appTitle);

    //SECTION OF STUDY
    section = document.createElement("h3");
    section.setAttribute("class", "sectionNumber");
    
    var sectionTitle = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    var text = document.createTextNode("Section " + sectionTitle.charAt(targetSection));
    section.appendChild(text);
    
    $('div.page-header').append(section);
    
    //GENERAL INFORMATION
    sectionContainer = document.createElement("div");
    sectionContainer.setAttribute("class", "sectionContainer");

    genInfo = document.createElement("h5");
    genInfo.setAttribute("class", "sectionTitle");

    var text = document.createTextNode(study.form.containedFormCollection[targetSection].containedForm.title);
    genInfo.appendChild(text);
    
    sectionContainer.appendChild(genInfo);
    
    comp = document.createElement("h5");
    comp.setAttribute("class", "sectionLocation");
    
    //need to update with actual section info
    var text = document.createTextNode("Completed: 0/11");
    comp.appendChild(text);

    sectionContainer.appendChild(comp);

    $('div.page-header').append(sectionContainer);
    
};

//*****************************************
//THIS CODE SHOULDN'T MAKE IT TO PRODUCTION
//ONLY FOR TESTING PURPOSES;
//attaching a select box for which test to
//run.
//*****************************************
function selectTest(){
    var selectContainer, testSelect;
    var tests = ["none", "user", "facility", "roles"];
    
    selectContainer = document.createElement("div");
    selectContainer.setAttribute("class", "selectCont");
    
    //current test
    var text = document.createTextNode("Select a test: ");

    selectContainer.appendChild(text);
    
    //test Selection
    testSelect = document.createElement("select");
    testSelect.setAttribute("class", "testSelect");
    testSelect.setAttribute("onChange", "genTest()");
    
    for(var i=0; i<tests.length; i++){
	var testOption = document.createElement("option");
	testOption.setAttribute("value", tests[i]);
	var text = document.createTextNode(tests[i]);
	testOption.appendChild(text);
	testSelect.appendChild(testOption);
    }

    selectContainer.appendChild(testSelect);

    return selectContainer;
};

//*****************************************
//THIS CODE SHOULDN'T MAKE IT TO PRODUCTION
//ONLY FOR TESTING PURPOSES
//based shows the current user or current
//facility as well as lets the user pick
//which one they want to use.
//*****************************************
function genTest(){
    var genContainer, genSelect, genList, genName, genIn, genSubmit, currentDiv;
    
    var selectedIndex = $('select.testSelect').find(':selected').index();
    var tests = ["none", "user", "facility", "role"];
    
    //cleaning out the previous test
    $('.genCont').remove();
	
    if(selectedIndex != 0){    
	genContainer = document.createElement("div");
	genContainer.setAttribute("class", "genCont");

	//displaying user, facility, or study that is in the database
	var text = document.createTextNode("select a " + tests[selectedIndex] + ": ");
	genContainer.appendChild(text);
	
	genSelect = document.createElement("select");
	genSelect.setAttribute("class", "genSelect");
	genSelect.setAttribute("onClick", "updateTest()");
	
	//show what roles the current user is mapped to
	//allow user to map current user to another role

	if(selectedIndex == 3){
	    genList = sendREST("GET", "fascade/roles", null, false);
	    
	    if(genList.roles.length === undefined)
		genList.roles = [genList.roles];
	    
	    //str.split(",");
	    console.log(genList.roles.length);

	    for(var i = 0; i < genList.roles.length; i++){
		var genOption = document.createElement("option"); 

		genOption.setAttribute("value", genList.roles[i][i]);
		var text = document.createTextNode(genList.roles[i][i]);

		genOption.appendChild(text);
		genSelect.appendChild(genOption);
	    }
	    
	    genContainer.appendChild(genSelect);
	    
	    var text = document.createTextNode(" To add to the current user: " + currentUser.loginName + " ");
	    genContainer.appendChild(text);
	    
	    //submit button
	    genSubmit = document.createElement("button");
	    genSubmit.setAttribute("type", "button");
	    genSubmit.setAttribute("onclick", "sendUser()");
	    
	    var text = document.createTextNode("Submit");
		
	    genSubmit.appendChild(text);
	    genContainer.appendChild(genSubmit);
	    
	    var elem = document.createElement("br");
	    genContainer.appendChild(elem);

	    var text = document.createTextNode("To add a new role, first give it an ID that hasn't been used ");
	    genContainer.appendChild(text);
	    
	    genIn = document.createElement("input");
	    genIn.setAttribute("class", "test");
	    genIn.setAttribute("type", "number");
	    
	    genContainer.appendChild(genIn);

	    var elem = document.createElement("br");
	    genContainer.appendChild(elem);

	    var text = document.createTextNode(" And give it a name ");
	    genContainer.appendChild(text);

	    genIn = document.createElement("input");
	    genIn.setAttribute("class", "test");
	    	    
	    genContainer.appendChild(genIn);

	    //submit button
	    genSubmit = document.createElement("button");
	    genSubmit.setAttribute("type", "button");
	    genSubmit.setAttribute("onclick", "sendRole()");
	    
	    var text = document.createTextNode("Submit");
		
	    genSubmit.appendChild(text);
	    genContainer.appendChild(genSubmit);
	}else{
	    genList = sendREST("GET", tests[selectedIndex], null, false);
	
	    for(var i=0; i<genList[tests[selectedIndex]].length; i++){
		var genOption = document.createElement("option");
		
		genOption.setAttribute("value", genList[tests[selectedIndex]][i].displayName || genList[tests[selectedIndex]][i].name);
		var text = document.createTextNode((genList[tests[selectedIndex]][i].displayName || genList[tests[selectedIndex]][i].name) +": " + (genList[tests[selectedIndex]][i].usersID || genList[tests[selectedIndex]][i].facilitiesID));
		
		genOption.appendChild(text);
		genSelect.appendChild(genOption);
	    }
	
	
	    genContainer.appendChild(genSelect);
	    
	    var elem = document.createElement("br");
	    genContainer.appendChild(elem);
	    
	    //inputting a new user/facility
	    var text = document.createTextNode("OR Enter a " +tests[selectedIndex]+ " name:");
	    genName = document.createElement("input");
	    genName.setAttribute("class", "test");
	    
	    genContainer.appendChild(text);
	    genContainer.appendChild(genName);
	    
	    //inputting a new user/facility ID
	    var text = document.createTextNode(" AND Enter a " +tests[selectedIndex]+ "ID:");
	    genIn = document.createElement("input");
	    genIn.setAttribute("class", "test");
	    genIn.setAttribute("type", "number");
	    
	    genContainer.appendChild(text);
	    genContainer.appendChild(genIn);
	
	
	    //submit button
	    genSubmit = document.createElement("button");
	    genSubmit.setAttribute("type", "button");
	    genSubmit.setAttribute("onclick", "genCreate()");
		
	    var text = document.createTextNode("Submit");
		
	    genSubmit.appendChild(text);
	    genContainer.appendChild(genSubmit);
	}

	var elem = document.createElement("br");
	genContainer.appendChild(elem);

	currentDiv = document.createElement("div");
	currentDiv.setAttribute("class", "testCurrDiv");

	//current user display
	var text = document.createTextNode("The current user is: " + currentUser.displayName +": "+ currentUser.usersID + " ");
	currentDiv.appendChild(text);
	
	//current facility display
	var text = document.createTextNode("The current faclity is: " + currentFacility.name +": "+ currentFacility.facilitiesID);
	currentDiv.appendChild(text);
	genContainer.appendChild(currentDiv);
      	
	//last attachment
	$('.selectCont').append(genContainer);
    }
    
};

function sendRole(){
    var selected = $('input.test');

    var request = new XMLHttpRequest();
    request.open("POST", restPath.concat("fascade/setrole/"+selected[0].value+"/role/"+selected[1].value), false);
    request.setRequestHeader("Content-Type", "text/plain");
    request.send(null);
    
    if(request.status === 200){
	console.log("user role added successfully");
    }else{
	console.log("couldn't add user role");
    }
};

function sendUser(){
    var selected = $('.genSelect').find(':selected').index();
        
    var request = new XMLHttpRequest();
    request.open("POST", restPath.concat("fascade/setuserrole/"+currentUser.usersID+"/roleid/"+selected), false);
    request.setRequestHeader("Content-Type", "text/plain");
    request.send(null);
    
    if(request.status === 200){
	console.log("user bonded sucessfully");
    }else{
	console.log("user didn't consume role");
    }

    //*******************************
    //NEED TO ADD VISUAL CONFIRMATION
    //*******************************
};

//*****************************************
//THIS CODE SHOULDN'T MAKE IT TO PRODUCTION
//ONLY FOR TESTING PURPOSES
//when user selects a new user/facility
//from the drop down box, this updates the
//current user/facility console.
//*****************************************
function updateTest(){
    var genList = [];
    var testIndex = $('select.testSelect').find(':selected').index();
    var selectedIndex = $('select.genSelect').find(':selected').index();
        
    //updating the current user/facility
    if(testIndex == 1){
	genList = sendREST("GET", "user", null, false);

	currentUser.displayName = genList.user[selectedIndex].displayName;
	currentUser.loginName = genList.user[selectedIndex].loginName;
	currentUser.permanentLoginIdentifier = genList.user[selectedIndex].permanentLoginIdentifier;
	currentUser.usersID = genList.user[selectedIndex].usersID;
    }else if(testIndex == 2){
	genList = sendREST("GET", "facility", null, false);
	
	currentFacility.administratorSPGroup = genList.facility[selectedIndex].administratorSPGroup;
	currentFacility.description = genList.facility[selectedIndex].description;
	currentFacility.facilitiesID = genList.facility[selectedIndex].facilitiesID;
	currentFacility.name = genList.facility[selectedIndex].name;
	currentFacility.reviewerSPCalendar = genList.facility[selectedIndex].reviewerSPCalendar;
	currentFacility.reviewerSPGroup = genList.facility[selectedIndex].reviewerSPGroup;
	currentFacility.safetySPGroup = genList.facility[selectedIndex].safetySPGroup;
    }
    
    //removing old user and test display
    $('.testCurrDiv').contents().remove();
    
    //current user display
    var text = document.createTextNode("The current user is: " + currentUser.displayName +": "+ currentUser.usersID + " ");
    $('.testCurrDiv').append(text);
    
    //current facility display
    var text = document.createTextNode("The current faclity is: " + currentFacility.name +": "+ currentFacility.facilitiesID);
    $('.testCurrDiv').append(text);
    
};


//*****************************************
//THIS CODE SHOULDN'T MAKE IT TO PRODUCTION
//ONLY FOR TESTING PURPOSES
//packaging up the user/facility that a
//user inputs and sends it to the database
//*****************************************
function genCreate(){
    var genIn = $('input.test');
    var testIndex = $('select.testSelect').find(':selected').index();
    var tests = ["none", "user", "facility"];
    
    if((genIn[0].value != "") && (genIn[1].value != "")){
	    
	//updating the current user/facility
	if(testIndex == 1){
	    genList = sendREST("GET", "user", null, false);
	    
	    currentUser.displayName = genIn[0].value;
	    currentUser.loginName = genIn[0].value;
	    currentUser.permanentLoginIdentifier = genIn[0].value;
	    currentUser.usersID = genIn[1].value;
	    	    
	    var user = {
		"user" : currentUser
	    };

	    sendREST("POST", "manage/user", user, true);
	}else if(testIndex == 2){
	    sendREST("GET", "facility", null, false);
	    
	    currentFacility.administratorSPGroup = 0;
	    currentFacility.description = "test add";
	    currentFacility.facilitiesID = genIn[1].value;
	    currentFacility.name = genIn[0].value;
	    currentFacility.reviewerSPCalendar = "00000000-0000-0000-0000-000000000000";
	    currentFacility.reviewerSPGroup = 0;
	    currentFacility.safetySPGroup = 0;
		    
	    var facility = {
		"facility" : currentFacility
	    };

	    sendREST("POST", "manage/facility", facility, true);
	    
	}
	//updating current user/facility display
	$('.testCurrDiv').contents().remove();
	
	//current user display
	var text = document.createTextNode("The current user is: " + currentUser.displayName +": "+ currentUser.usersID + " ");
	$('.testCurrDiv').append(text);
	
	//current facility display
	var text = document.createTextNode("The current faclity is: " + currentFacility.name +": "+ currentFacility.facilitiesID);
	$('.testCurrDiv').append(text);
    }
};

//used to warn alert users in a 508 compliant way
function insertWarning(message){
    var warnCont, bolded;
    
    //assuring only one warning appears at a time
    $('.alert-warning').remove();

    warnCont = document.createElement("div");
    warnCont.setAttribute("class", "alert alert-warning");
    warnCont.setAttribute("role", "alert");

    bolded = document.createElement("strong");
    var text = document.createTextNode("Warning! ");
    bolded.appendChild(text);
    warnCont.appendChild(bolded);

    var text = document.createTextNode(message);
    warnCont.appendChild(text);
    
    $('.page-header').append(warnCont);
    $('html, body').animate({
	    scrollTop: $('.navbar').offset().top
	}, 200);
};

//connects to a rest endpoint and either sends or
//recieves data
function sendREST(httpMethod, endpoint, data, sync){
    var xmlResponse;
    if(window.XMLHttpRequest){
	xmlResponse = new XMLHttpRequest();
    }else{
	xmlResponse = new ActiveXObject("Microsoft.XMLHTTP");
    }

    try{
	xmlResponse.open(httpMethod, restPath.concat(endpoint), sync);
	xmlResponse.setRequestHeader("Content-Type", "application/json");
	xmlResponse.setRequestHeader("Accept", "application/json");
	
	if((httpMethod == "PUT")||(httpMethod == "DELETE")){
	    xmlResponse.setRequestHeader("sm_user", data);
	    xmlResponse.send(null);
	    if(xmlResponse.status === 204){
		return true;
	    }else if(xmlResponse.status === 403){
		return false;
	    }
	}
	if(httpMethod == "POST"){
	    try{
		xmlResponse.send(JSON.stringify(data));
		alert("You have submitted data to" +restPath.concat(endpoint));
	    }catch(e){
		alert(e.toString());
	    }
	}
	if(httpMethod == "GET"){
	    xmlResponse.onreadystatechange = function(){
		if(xmlResponse.readyState === 4){
		    if(xmlResponse.status === 200){
			
			try{
			    xmlResponse = JSON.parse(xmlResponse.responseText);
			    
			}catch(e){
			    alert(e.toString());
			}
			
		    }else{
			alert(xmlResponse.statusText);
		    }
		}
	    };
	    xmlResponse.send(null);
	    return xmlResponse;
	}

    }catch(e){
	alert(e.toString());
    }
};

//Takes the response from the database and builds the questions displayed
//in the application.
function questionBuilder(section){
    changedQuestions = new HashSet();
    
    for(var i=0; i<section.containedForm.formQuestionCollection.length; i++){
	var form, formGroup, textLabel, text, input, toolSpan;
	var formQuestion = section.containedForm.formQuestionCollection[i];
	
	form = document.createElement("form");
	
	//div containing complete questions
	formGroup = document.createElement("div");
	formGroup.setAttribute("class", "form-group");
		
	//question text
	textLabel = document.createElement("label");
	textLabel.setAttribute("for", formQuestion.question.questionsID);
	
	text = document.createTextNode(formQuestion.question.questionHyperText);
	textLabel.appendChild(text);
	
	//**********************************
	//PLACEMENT OF TOOLTIP ISN'T OPTIMAL
	//it's in the label, instead of 
	//just being in the div.
	//need to get with Nick
	//**********************************

	//tooltip logic
	if(formQuestion.question.helpHyperText){
	    toolSpan = document.createElement("span");
	    toolSpan.setAttribute("data-toggle", "tooltip");
	    toolSpan.setAttribute("data-placement", "right");
	    toolSpan.setAttribute("title", "Tooltip");
	    toolSpan.setAttribute("class", "glyphicon glyphicon-question-sign");
	
	    textLabel.appendChild(toolSpan);
	}
	
	//question input
	if((formQuestion.question.responseFormat.name == "radio") || (formQuestion.question.responseFormat.name == "checkbox")){
	    //question input for radios and checkboxes
	    form.appendChild(textLabel);
	    form.appendChild(formGroup);

	    for(var j=0; j<formQuestion.question.answerCollection.length; j++){
		var answerLabel = document.createElement("label");
			
		//radio button formatting
		if((formQuestion.question.responseFormat.name == "radio") && (formQuestion.question.answerCollection[j].value.length < 6)){
		    answerLabel.setAttribute("class", "radio-inline");
		}else if((formQuestion.question.responseFormat.name == "radio") && (formQuestion.question.answerCollection[j].value.length >= 6)){
		    answerLabel.setAttribute("class", "radio");
		}else if(formQuestion.question.responseFormat.name == "checkbox"){
		    answerLabel.setAttribute("class", "checkbox");
		}
		
		var input = document.createElement("input");
		input.setAttribute("type", formQuestion.question.responseFormat.name);
		input.setAttribute("name", formQuestion.question.questionsID);
		input.setAttribute("id", /*"inlineRadio" + (j+1) + " " +*/ formQuestion.question.answerCollection[j].answersID);
		
		if(formQuestion.question.responseFormat.name == "checkbox"){
		    input.setAttribute("title", formQuestion.question.answerCollection[j].sequencePosition);
		    input.setAttribute("onchange", "Function(changedQuestions.add("+formQuestion.question.answerCollection[j].answersID+"))");
		}else{
		    input.setAttribute("onchange", "Function(changedQuestions.add("+formQuestion.question.questionsID+"))");
		}
		if(rollup.questionResponseUpdates.responses === undefined){
		    
		}else{
		    //looking for responses
		    for(var x=0; x<rollup.questionResponseUpdates.responses.length; x++){
			if((rollup.questionResponseUpdates.responses[x].questionsID == formQuestion.question.questionsID) && (rollup.questionResponseUpdates.responses[x].answersID) == formQuestion.question.answerCollection[j].answersID){
			    input.checked = true;
			}
		    }
		}
		
		var value = document.createTextNode(formQuestion.question.answerCollection[j].value);
		
		answerLabel.appendChild(input);
		answerLabel.appendChild(value);
		
		formGroup.appendChild(answerLabel);
		$('div.formContent').append(form);
	    }
	}else if(formQuestion.question.responseFormat.name == "select"){
	    formGroup.appendChild(textLabel);
	    form.setAttribute("role", "form")
	    form.appendChild(formGroup);
	    
	    input = document.createElement("select");
	    var inputOption = document.createElement("option");
	    inputOption.setAttribute("value", "none");
	    var text = document.createTextNode("none");
	    inputOption.appendChild(text);
	    input.appendChild(inputOption);

	    input.setAttribute("name", formQuestion.question.questionsID);
	    input.setAttribute("class", "form-control normal");

	    formGroup.appendChild(input);
	    $('div.formContent').append(form);
	}else{
	    //question input for everything else
	    formGroup.appendChild(textLabel);
	    //if(toolSpan)
	      //formGroup.appendChild(toolSpan);
	    form.setAttribute("role", "form");
	    form.appendChild(formGroup);

	    input = document.createElement("input");
	    input.setAttribute("type", formQuestion.question.responseFormat.name);
	    input.setAttribute("name", formQuestion.question.questionsID);
	    input.setAttribute("class", "form-control normal");
	    input.setAttribute("onchange", "Function(changedQuestions.add("+formQuestion.question.questionsID+"))");
	    
	    if(rollup.questionResponseUpdates.responses === undefined){
	    }else{
		//looking for responses
		for(var x=0; x<rollup.questionResponseUpdates.responses.length; x++){
		    if(rollup.questionResponseUpdates.responses[x].questionsID == formQuestion.question.questionsID){
			input.value = rollup.questionResponseUpdates.responses[x].response;
		    }
		}
	    }

	    formGroup.appendChild(input);
	    $('div.formContent').append(form);
	    
	}

	//checking to see if the question has a dependency on another answer
	if(formQuestion.requiredPredecessorAnswersID){	    
	    questionRequirement(formQuestion, input);
	}
    }
    checkLock(section.containedForm.formsID, "acquire");
};

//looks for unsaved responses and alerts the user to save before
//moving on to another section
function checkSave(targetSection){
    
    if(changedQuestions.isEmpty()){
	sectionBuilder(targetSection);
    }else{
	if($('.alert-warning').length != 0){
	    console.log("banner in place");
	    sectionBuilder(targetSection);
	}else{
	    insertWarning("You have unsaved responses. Please click the Save Progress button at the bottom of the page or your changes will be lost.");
    	}
    }
};

//updating the locks that users hold on sections.
function checkLock(sectionID, action){
    var key;
    
    if(currentUser.loginName === null){
	$('input').attr("disabled", true);
	$('select').attr("disabled", true);
	//need to be able to select a user
	$('.testSelect').removeAttr("disabled");
	insertWarning("You must choose a user to proceed");
    }else if(action == "acquire"){
	key = sendREST("PUT", "study/1/lock/"+sectionID, currentUser.loginName, false);
	
	if(key == false){
	    insertWarning("Another user is editing this section");
	    $('input').attr("disabled", true);
	}
    }else if(action == "release"){
	key = sendREST("DELETE", "study/1/lock_u/"+sectionID, currentUser.loginName, false);
	
	if(key == true){
	    $('input').attr("disabled", true);
	}
    }
};

//some questions are optional, this goes through the optional questions and
//sets up the proper dependencies on the front end to allow for activation
//and deactivation of questions.
function questionRequirement(formQuestion, input){
    
	    //general queries
	    var parentAnswer = $('#'+formQuestion.requiredPredecessorAnswersID);
	    var radioPair;

	    //checkboxes have a listener on the one checkbox, but radios need a 
	    //listener to turn on the question and a listener to turn off the question.
	    //this requires us to query the yes/no radio buttons and attach a listener to each.
	    if(parentAnswer.attr("type")=="checkbox"){
		if(!(parentAnswer.attr('onclick')))
		    parentAnswer.attr("onclick", "activateQuestion("+formQuestion.requiredPredecessorAnswersID+")");
	    }else if(parentAnswer.attr("type")=="radio"){
		radioPair = $('[name="'+($('#'+formQuestion.requiredPredecessorAnswersID).attr("name"))+'"]');
		if(!(radioPair.attr('onclick'))){
		    
		    for(var j=0; j<radioPair.length; j++){
			radioPair[j].setAttribute("onclick", "activateQuestion("+formQuestion.requiredPredecessorAnswersID+")");
		    }
		}
	    }

	    //checking to see if there is already an established key for this answer
	    if(dependency.containsKey(formQuestion.requiredPredecessorAnswersID)){
		//checking to see if answer is checked or not. 
		//**********************************************************
		//may not work if you depend on an answer in another section
		//**********************************************************
		if(!(parentAnswer.is(':checked'))){
		    if((input.getAttribute("type") == "radio") ||(input.getAttribute("type") == "checkbox")){
			$('[name="'+input.name+'"]').attr("disabled", true);
		    }else{ 
			input.setAttribute("disabled", true);
		    }
		}

		//adding id to the set of questions affected by an answer.
		if(!(dependency.get(formQuestion.requiredPredecessorAnswersID)).contains(formQuestion.question.questionsID)){
		    (dependency.get(formQuestion.requiredPredecessorAnswersID)).add(formQuestion.question.questionsID);
		}
		
	    }else{
		//instantiating the answer in the dependency map and giving it a set of questions it affects.
		var temp = new HashSet();
		temp.add(formQuestion.question.questionsID);
		dependency.put(formQuestion.requiredPredecessorAnswersID, temp);
		
		//checking to see if answer is checked or not. 
		//**********************************************************
		//may not work if you depend on an answer in another section
		//**********************************************************
		if(!(parentAnswer.is(':checked'))){
		    if((input.getAttribute("type") == "radio") ||(input.getAttribute("type") == "checkbox")){
			$('[name="'+input.name+'"]').attr("disabled", true);
		    }else{ 
			input.setAttribute("disabled", true);
		    }
		}
	    }

//$('[name="'input.name'"]').attr("disabled", true);
};

//This function toggles if a question is activated or
//deactivated.
function activateQuestion(answersId){
    var set = (dependency.get(answersId)).values();
    
    for(var i=0; i<set.length; i++){
	if(!($('#'+answersId).is(':checked'))){
	    $('[name="'+set[i]+'"]').attr("disabled", true);
	}else{
	    $('[name="'+set[i]+'"]').attr("disabled", false);
	}	    
    }
};

//Builds the buttons that appear at the bottom of the page 
function progressBuilder(targetSection){
    var spButton;

    //Cancel Button
    csButton = document.createElement("button");
    csButton.setAttribute("type", "button");
    csButton.setAttribute("class", "btn btn-default pull-left");
    csButton.setAttribute("onclick", "Function(checkLock("+ study.form.containedFormCollection[targetSection].containedForm.formsID +",'release'), location.href='irb-home.html')");  
	
    var text = document.createTextNode("Cancel");
    csButton.appendChild(text);
    $('div.progress-container').append(csButton);

    //save progress button
    spButton = document.createElement("button");
    spButton.setAttribute("type", "button");
    spButton.setAttribute("class", "btn btn-default pull-right");
    spButton.setAttribute("onclick", "createResponses()");

    var text = document.createTextNode("Save Progress");
    
    spButton.appendChild(text);
    $('div.progress-container').append(spButton);
};

//Builds the buttons that appear on top of the sidebar which
//allow users to upload documents and print a section
function actionBarBuilder(targetSection){
    var actionTools, printList, printLink, printIcon;
    var uploadList, uploadLink, uploadIcon, uploadInput;
    var sectionTitle = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";    

    actionTools = document.createElement("ul");
    actionTools.setAttribute("class", "actionTools");

    printList = document.createElement("li");
    
    printLink = document.createElement("a");
    printLink.setAttribute("href", "#");
    printLink.setAttribute("title", "");

    printIcon = document.createElement("span");
    printIcon.setAttribute("class", "glyphicon glyphicon-print");
    printLink.appendChild(printIcon);

    var text = document.createTextNode("Print Section " + sectionTitle.charAt(targetSection));
    printLink.appendChild(text);

    printList.appendChild(printLink);
    actionTools.appendChild(printList);

    uploadList = document.createElement("li");

    uploadInput = document.createElement("input");
    uploadInput.setAttribute("id", "upload");
    uploadInput.setAttribute("type", "file");
    uploadInput.style.display = "none";

    uploadLink = document.createElement("a");
    uploadLink.setAttribute("href", "#");
    uploadLink.setAttribute("title", "");
    uploadLink.setAttribute("onclick", "Function($('#upload').trigger('click'), changedQuestions.add(0000))");
    
    uploadIcon = document.createElement("span");
    uploadIcon.setAttribute("class", "glyphicon glyphicon-upload");
    uploadLink.appendChild(uploadIcon);

    var text = document.createTextNode("Upload Document(s)");
    uploadLink.appendChild(text);

    uploadList.appendChild(uploadInput);
    uploadList.appendChild(uploadLink);
    actionTools.appendChild(uploadList);
    
    $('div.actionbar').append(actionTools);
};

//creates the rest of the sidebar including the sections
//and the buttons that allow you to review and submit
function wellSidebarBuilder(targetSection){
    var listGroup, lGroup;
        
    $('.list-group').remove();

    listGroup = document.createElement("div");
    listGroup.setAttribute("class", "list-group");

    for(var i=0; i<study.form.containedFormCollection.length; i++){
	var link = document.createElement("a");
	link.setAttribute("onclick", "Function(checkLock("+ study.form.containedFormCollection[targetSection].containedForm.formsID +",'release'), checkSave("+i+"))");  
	//link.setAttribute("onclick", "Function(checkSave("+i+"))");  

	if(i == targetSection){
	    link.setAttribute("class", "list-group-item active");
	}else{
	    link.setAttribute("class", "list-group-item");
	}
	
	//*********
	//QUICK FIX
	//*********
	var sectionTitle = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

	var text = document.createTextNode("Section " + sectionTitle.charAt(i));
	link.appendChild(text);
	
	listGroup.appendChild(link);
    }
    
    $('div.well').append(listGroup);

    lGroup = document.createElement("div");
    lGroup.setAttribute("class", "list-group");

    var link = document.createElement("a");
    //link.setAttribute("href", "");
    link.setAttribute("class", "list-group-item");
    
    var text = document.createTextNode("Attachments");
    link.appendChild(text);
    
    var icon = document.createElement("span");
    icon.setAttribute("class", "badge");
    
    var text = document.createTextNode("0");
    icon.appendChild(text);

    link.appendChild(icon);

    lGroup.appendChild(link);

    var link = document.createElement("a");
    //link.setAttribute("href", "");
    link.setAttribute("class", "list-group-item");
    
    var text = document.createTextNode("Review & Submit");
    link.appendChild(text);
    
    var icon = document.createElement("span");
    icon.setAttribute("class", "glyphicon glyphicon-chevron-right");
    
    link.appendChild(icon);

    lGroup.appendChild(link);

    $('div.well').append(lGroup);
    
    //updating sidebar icons
    updateSidebarIcons(targetSection);
};

//assigning the appropriate icons the buttons in the sidebar
function updateSidebarIcons(targetSection){
    //grabbing all of the section buttons
    var sideButtons = $('.list-group-item');
    var sectionTitle = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

    //removing previous icons
    $('.glyphicon-adjust').remove();
    $('.glyphicon-record').remove();
    $('.glyphicon-ok-cirlce').remove();
    
    for(var i=0; i<sideButtons.length-2; i++){
	if((rollup.questionResponseUpdates.formValidationReport.formStatusCollection[0].status != "INCOMPLETE")&&(i!=0)){
	    sideButtons[i].setAttribute("onclick", "insertWarning('You must complete Section A and Save your responses before proceeding.')");
	}else{
	    var icon = document.createElement("span");
	    if(rollup.questionResponseUpdates.formValidationReport.formStatusCollection[i].status == "INCOMPLETE"){
		icon.setAttribute("class", "glyphicon glyphicon-adjust");
		sideButtons[i].setAttribute("onclick", "Function(checkLock("+ study.form.containedFormCollection[targetSection].containedForm.formsID +",'release'), checkSave("+i+"))");  
	    }else if(rollup.questionResponseUpdates.formValidationReport.formStatusCollection[i].status == "NOT_APPLICABLE"){
		//no icon
		sideButtons[i].removeAttribute("onclick");
		//sideButtons[i].setAttribute("onclick", "insertWarning('You do not have to complete Section ' +" +sectionTitle.charAt(i)+" + ')'");

	    }else if(rollup.questionResponseUpdates.formValidationReport.formStatusCollection[i].status == "EMPTY"){
		icon.setAttribute("class", "glyphicon glyphicon-record");
		sideButtons[i].setAttribute("onclick", "Function(checkLock("+ study.form.containedFormCollection[targetSection].containedForm.formsID +",'release'), checkSave("+i+"))");  
	    }else if(rollup.questionResponseUpdates.formValidationReport.formStatusCollection[i].status == "COMPLETE"){
		icon.setAttribute("class", "glyphicon glyphicon-ok-circle");
		sideButtons[i].setAttribute("onclick", "Function(checkLock("+ study.form.containedFormCollection[targetSection].containedForm.formsID +",'release'), checkSave("+i+"))");  
	    }
	    sideButtons[i].appendChild(icon);
	}
    }
    
};

//post to feed with accept and content-type set to application/json. just need to send
//the last updated at
//should be initialized when application is first being built, then it will
//sustain itself
function subscriptionFeed(){
    var feedXML;

    //creating the correct request to talk to server
    if(window.XMLHttpRequest){
	feedXML = new XMLHttpRequest();
    }else{
	feedXML = new ActiveXObject("Microsoft.XMLHTTP");
    }
    
    try{
	//need to grab study id from sharepoint
	feedXML.open("POST", restPath+"study/1/responses/"+recentStage+"/feed")
	feedXML.setRequestHeader('Accept', 'application/json');
	feedXML.setRequestHeader('Content-Type', 'application/json');
	
	try{
	    feedXML.send(JSON.stringify(feedResponse || rollup));
	}catch(e){
	    alert(e.toString());
	}
	
	try{
	    feedXML.onreadystatechange = function(){
		if(feedXML.readyState === 4){
		    if(feedXML.status === 200){
			try{
			    feedResponse = JSON.parse(feedXML.responseText);
			    updateRollup(feedResponse);
			}catch(e){
			    //alert(e.toString() + " 1022");
			    //getting section validation, but no responses from feed
			}
		    }else{
			//refresh error here
			//alert(feedXML.statusText + " 742");
		    }
		    //opening up the feed after closing it
		    subscriptionFeed();
		}
	    }
	}catch(e){
	    alert(e.toString() + " 749");
	}
	
    }catch(e){
	alert(e.toString() + "753");
    }
};

//inserts answers that have changed while user is filling
//out application
function updateRollup(feedResponse){
    //********************************
    //WILL HAVE ISSUES WITH CHECKBOXES
    //RESPONSES THAT HAVEN'T BEEN STORED BEFORE
    //WONT MAKE IT INTO THE ROLLUP.
    //********************************

    var safeCheckResponse;
    var found=false;
    
    //changing json format
    if(feedResponse.questionResponseUpdates.responses.length === undefined){
	safeCheckResponse = feedResponse;
	safeCheckResponse.questionResponseUpdates.responses = [safeCheckResponse.questionResponseUpdates.responses];
    }else{
	safeCheckResponse = feedResponse;
    }
    
    for(var i=0; i<safeCheckResponse.questionResponseUpdates.responses.length; i++){
	found = false;
	for(var j=0; j<rollup.questionResponseUpdates.responses.length; j++){
	    var scQuestionsID = safeCheckResponse.questionResponseUpdates.responses[i].questionsID;
	    var scAnswersID = safeCheckResponse.questionResponseUpdates.responses[i].answersID;
	    var scCheckboxIndex = safeCheckResponse.questionResponseUpdates.responses[i].checkboxIndex;
	    var rQuestionsID = rollup.questionResponseUpdates.responses[j].questionsID;
	    var rAnswersID = rollup.questionResponseUpdates.responses[j].answersID;
	    var rCheckboxIndex = rollup.questionResponseUpdates.responses[j].checkboxIndex;
	    
	    if((scCheckboxIndex == rCheckboxIndex) && (scQuestionsID == rQuestionsID)){
		//checkbox replacement
		rollup.questionResponseUpdates.responses[j] = safeCheckResponse.questionResponseUpdates.responses[i];
		found = true;
		break;		
	    }else if(!("checkboxIndex" in safeCheckResponse.questionResponseUpdates.responses[i]) && (scQuestionsID == rQuestionsID)){
		//radio, text, select
		rollup.questionResponseUpdates.responses[j] = safeCheckResponse.questionResponseUpdates.responses[i];
		found = true;
		break;
	    }
	}
	//not found, adding
	if(found == false){
	    rollup.questionResponseUpdates.responses.push(safeCheckResponse.questionResponseUpdates.responses[i]);
	}
    }

    rollup.questionResponseUpdates.formValidationReport = safeCheckResponse.questionResponseUpdates.formValidationReport;
    
    //************************************
    //CONSIDER MAKING TARGETSECTION GLOBAL
    //************************************
    //getting current target section to pass 
    var sidebar = $('.list-group-item');
    var current = $('.list-group-item.active');
    for(var i=0; i<sidebar.length-2; i++){
	if(sidebar.get(i) == current.get(0)){
	    //updating sidebar icons
	    updateSidebarIcons(i);
	}
    }
};

//grabbing all user input and packaging it up to send
function createResponses(){
    var changedPackage; 
    var qResponse = {};
    var data = [];
    var response = {};
    var question; 
    
    //FASCADE
    if($('#upload').val()){
	var file = $('#upload').val();
	var formData = new FormData();
	formData.append("file", file);
	formData.append("login_name", currentUser.loginName);
	formData.append("study_id", 1);

	console.log("looks like something was uploaded " + formData);
	
	var request = new XMLHttpRequest();
	request.open("POST", restPath.concat("fascade/file/upload"), false);
	request.setRequestHeader("Content-Type", "multipart/form-data");
	request.send(formData);
	
	if(request.status === 200){
	    console.log("file uploaded successfully");
	}else{
	    console.log("file upload failed");
	}
    }
    //changed questions keeps track of what questions the user
    //has modified while filling out the current section
    changedPackage = changedQuestions.values();
    changedQuestions = new HashSet();
    
    for(var i=0; i<changedPackage.length; i++){
	var toPackage = $('[name="'+changedPackage[i]+'"], #'+changedPackage[i]+'');
	if((toPackage.length > 1) && (toPackage[0].type == "radio")) {
	    for(var j=0; j<toPackage.length; j++){
		//have to grab the set of radios assigned to a questions and see 
		//which one is actually selected to send to the database
		if(toPackage[j].checked == true){
		    response = {
			"answersID": toPackage[j].id,
			"questionsID": toPackage[j].name
		    };
		    data.push(response);
		}
	    }
	}else if((toPackage.length == 1) && (toPackage[0].type == "checkbox")){
	    if(toPackage[0].checked == true){
		response = {
		    "answersID": toPackage[0].id,
		    "checkboxIndex": toPackage[0].title,
		    "questionsID": toPackage[0].name
		};
		data.push(response);
	    }else if(toPackage[0].checked == false){
		response = {
		    "checkboxIndex": toPackage[0].title,
		    "questionsID": toPackage[0].name
		};
		data.push(response);
	    }
	}else if(toPackage.length == 1){
	    response = {
		"questionsID": toPackage[0].name,
		"response": toPackage[0].value
	    };
	    data.push(response);
	}else{
	    //alert("NOT CAUGHT in createResponses");
	    //no response
	}
	
    }
    
    //properly packaging to send through REST call
    qResponse = {
	"questionResponse": data
    };
    
    //REST call
    if(data[0] != null)
	sendREST("POST", "study/1/responses/"+recentStage, qResponse, true);
};