/***************************************************
E1.0.0 RAM Increment 1 Final Code
December 2014
Department of Veteran's Affairs/Booz Allen Hamilton
dynamicDashboard.js
***************************************************/

//Linking in the sql database
var restPath = "http://vaausramapp801.srv.domain:8080/RAMS-0.0.1/";
//Linking in the sharepoint site
var siteUrl = "http://ram-spdev.aac.dva.domain/sites/RAMS_Test/";

//globals that have to be shared between functions
var retrievedUser, id;
    
function process(){
    //loading connection to sharepoint
    var clientContext = new SP.ClientContext(siteUrl);
    
    this.website = clientContext.get_web();
    this.currentUser_SP = website.get_currentUser();
    clientContext.load(currentUser_SP);
    //trying to grab username information from sharepoint
    clientContext.executeQueryAsync(Function.createDelegate(this, this.userQuerySucceeded), Function.createDelegate(this, this.userQueryFailed));
};

//When we know that we have successfully retrieved a username from
//shareponit, then we can set up the baseline information that is needed.
function userQuerySucceeded(sender, args) {
    var username_SP, split;
    
    //parsing out the needed username from sharepoint
    username_SP = currentUser_SP.get_loginName();
    split = username_SP.split("\\");
    retrievedUser = split[1];
        
    //grabs a new generated study id    
    var temp = sendREST("GET", "fascade/studyidgenerator/sitecode/1111/humorani/H", null, false);
    id = temp.studyAssignedID;

    $('.start').attr("onclick", "createStudy()");
    $('.start').attr("href", "irb-applications-general.html?" + id + "?" + retrievedUser);
	$('.start').html("Start IRB Application");
};

function userQueryFailed(sender, args) {
    alert('request failed ' + args.get_message() + '\n' + args.get_stackTrace());
};

function createStudy(){
    var facilities, users, studies;
    var userTable = new Hashtable();

    facilities = sendREST("GET", "facility", null, false);
    if(facilities.facility.length === undefined)
        facilities.facility = [facilities.facility];
    
    users = sendREST("GET", "user", null, false);
    if(users.user.length === undefined)
        users.user = [users.user];
        
    if(facilities.facility.length == 0){
    	var addFacility = {
    	    "administratorSPGroup": 0,
    	    "description": "initial facility",
    	    "facilitiesID": 0,
    	    "name": "General Site",
    	    "reviewerSPCalendar": "00000000-0000-0000-0000-000000000000",
    	    "reviewerSPGroup": 0,
    	    "safetySPGroup": 0
    	};
    	
    	facility = {
    	    "facility": addFacility
    	};
    	
    	sendREST("POST", "manage/facility", facility, false);
    }

    //checking to see if the user is in the sql database
    for(var i=0; i<users.user.length; i++){
        userTable.put(users.user[i].displayName, users.user[i].usersID);
    }
    
    //adding the user to the database if need be
    if(!userTable.containsKey(retrievedUser)){
    	var currentUser={
    	    "displayName": retrievedUser,
    	    "loginName": retrievedUser,
    	    "permanentLoginIdentifier": retrievedUser,
    	    "usersID": userTable.size()
    	};
    	
    	user = {
    	    "user" : currentUser
    	};
    	
    	userTable.put(currentUser.displayName, currentUser.usersID);
    	sendREST("POST", "manage/user", user, false);
    }
    

    studies = sendREST("GET", "manage/study", null, false);
    if(studies.study.length === undefined)
        studies.study = [studies.study];

    if(studies.study.length === undefined){
        studyID=1;
    }else{
        studyID = studies.study.length+1;
    }

    //packaging study
    facility = {
	   "facilitiesID": facilities.facility[0].facilitiesID
    };

    study = {
    	"assignedID": id,
    	"facility": facility,
    	"studiesID": studyID,
    	"title": "New IRB Application"
    };

    var data = {
	   "study": study
    };

    sendREST("POST", "manage/study?user=" + userTable.get(retrievedUser), data, false);
};

function sendREST(httpMethod, endpoint, data, sync){
    var xmlResponse;
    if(window.XMLHttpRequest){
        xmlResponse = new XMLHttpRequest();
    }else{
        xmlResponse = new ActiveXObject("Microsoft.XMLHTTP");
    }

    try{
        xmlResponse.open(httpMethod, restPath.concat(endpoint), sync);
        xmlResponse.setRequestHeader("Content-Type", "application/json");
        xmlResponse.setRequestHeader("Accept", "application/json");

        if((httpMethod == "PUT")||(httpMethod == "DELETE")){
            xmlResponse.setRequestHeader("sm_user", data);
            xmlResponse.send(null);
            if(xmlResponse.status === 204){
                return true;
            }else if(xmlResponse.status === 403){
                return false;
            }
        }
        if(httpMethod == "POST"){
            try{
                xmlResponse.send(JSON.stringify(data));
		alert("You have submitted data to" +restPath.concat(endpoint));
            }catch(e){
                alert(e.toString());
            }
        }
        if(httpMethod == "GET"){
            xmlResponse.onreadystatechange = function(){
                if(xmlResponse.readyState === 4){
                    if(xmlResponse.status === 200){

                        try{
                            xmlResponse = JSON.parse(xmlResponse.responseText);

                        }catch(e){
                            alert(e.toString());
                        }

                    }else{
                        alert(xmlResponse.statusText);
                    }
                }
            };
            xmlResponse.send(null);
            return xmlResponse;
        }

    }catch(e){
        alert(e.toString());
    }
};